InstantSearch / React / V6 / Guides

Upgrading React InstantSearch

Deprecated content
This documentation is for a deprecated version of React InstantSearch. Some features and settings may be missing or their usage may have changed. Refer to the documentation for the latest version of React InstantSearch for up-to-date information.

Upgrade from v5 to v6

Version 6 of React InstantSearch leverages the Context API that was released part of React 16.3.0. This means version 6 of React InstantSearch requires React 16.3.0 or higher.

React InstantSearch is compliant with StrictMode, for which the following breaking changes were introduced:

Server-side rendered (SSR) API

The SSR API only uses the server module on the server instead of on both the server and the client.

Support was added for searchClient hydration. The request used to happen on the server, but also on the client once the app was mounted. Because the state is passed from the server to the client, the initial client request was useless and is now re-used from the server request.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
// server.js

import React from 'react';
import { renderToString } from 'react-dom/server';
+import { findResultsState } from 'react-instantsearch-dom/server';
-import { App, findResultsState } from './App';
+import { App } from './App';

+const indexName = 'instant_search';
+const searchClient = algoliasearch(
+  'latency',
+  '6be0576ff61c053d5f9a3225e2a90f76'
+);

server.get('/', async (req, res) => {
  const initialState = {
-    resultsState: await findResultsState(App)
+    resultsState: await findResultsState(App, {
+      indexName,
+      searchClient
+    })
  };

  const plainHTML = renderToString(<App {...initialState} />);

  // ...
});
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
// browser.js

import React from 'react';
import { hydrate } from 'react-dom';
import { App } from './App';

+const indexName = 'instant_search';
+const searchClient = algoliasearch(
+  'latency',
+  '6be0576ff61c053d5f9a3225e2a90f76'
+);

hydrate(
  <App
    {...window.__APP_INITIAL_STATE__}
+   indexName={indexName}
+   searchClient={searchClient}
  />,
  document.getElementById('root')
);
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
// App.js

import React from 'react';
-import { liteClient as algoliasearch } from 'algoliasearch/lite';
-import { createInstantSearch } from 'react-instantsearch-dom/server';
-import { SearchBox } from 'react-instantsearch-dom';
+import { InstantSearch, SearchBox } from 'react-instantsearch-dom';

-const { InstantSearch, findResultsState } = createInstantSearch();

-const searchClient = algoliasearch(
-  'latency',
-  '6be0576ff61c053d5f9a3225e2a90f76'
-);

-const App = ({ resultsState }) => (
+const App = ({ indexName, searchClient, resultsState, onSearchParameters }) => (
  <InstantSearch
-   indexName="instant_search"
+   indexName={indexName}
    searchClient={searchClient}
    resultsState={resultsState}
+   onSearchParameters={onSearchParameters}
  >
    <SearchBox />
  </InstantSearch>
);

-export { App, findResultsState };
+export { App };

You might notice some duplications inside the preceding server and browser modules. The declaration of indexName and searchClient was duplicated. You can avoid this with a createApp function that returns the App and the props that you must provide. You can find this pattern applied inside the complete SSR example.

Removed support for appId and apiKey

Reach InstantSearch no longer supports the appId and apiKey props on instantsearch. Configure an algoliasearch client and pass it to the searchClient prop to configure your credentials.

The benefit of this change is that since algoliasearch is no longer shipped with React InstantSearch, you can use any SearchClient you want to use.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
import React from 'react';
+import { liteClient as algoliasearch } from 'algoliasearch/lite';
import { InstantSearch, SearchBox } from 'react-instantsearch-dom';

+const searchClient = algoliasearch(
+  'latency',
+  '6be0576ff61c053d5f9a3225e2a90f76'
+);

const App = () => (
  <InstantSearch
-   appId="latency"
-   apiKey="6be0576ff61c053d5f9a3225e2a90f76"
    indexName="instant_search"
+   searchClient={searchClient}
  >
    <SearchBox />
  </InstantSearch>
);

Removed support for root in InstantSearch and Index

The root prop in instantsearch and index-widget is no longer used. The top-level element is the Context.Provider, which doesn’t render anything.

You can wrap the element provided to root directly around instantsearch, which is useful for React Native users.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
// ...

const App = () => (
+  <section style={{ display: 'flex' }}>
    <InstantSearch
      indexName="instant_search"
      searchClient={searchClient}
-      root={{
-        Root: 'section',
-        props: {
-          style: {
-            display: 'flex',
-          },
-        },
-      }}
    >
      <SearchBox />
    </InstantSearch>
+  
);

algoliasearch-helper 3.x.x

We upgraded algoliasearch-helper to version 3. This means that if you interact with a SearchResults or SearchParameters object, the breaking changes there will affect your code. This usually only impacts you if you create a custom connector with createConnector.

There are no longer default values for the page (0) and query (‘’) search parameters. Both default to undefined when no value is assigned.

The function getQueryParameter was removed in favor of calling the getter for that parameter.

This version of algoliasearch-helper no longer includes Lodash, which significantly reduces its bundle size (from 27.5KB to 9.1KB Gzipped). If you’re using any methods from the helper, searchParameters or searchResults, please refer to the detailed change log of the package.

Package imports since 5.2.0

With the release of the version 5.2.0, we completely revamped the architecture of the package while keeping it backward compatible. The only case where changes are required is when you are using the private imports:

1
2
3
4
5
// Still works with `react-instantsearch` ≥ `5.2.0`
import { InstantSearch } from 'react-instantsearch/dom';

// Doesn't work with `react-instantsearch` ≥ `5.2.0`
import { InstantSearch } from 'react-instantsearch/es/widgets/SearchBox';

We’ve never documented the latter although it was handy to use; the default import was not compatible with tree shaking. For this reason, we decided to update our package to be compatible with tree shaking by default. To achieve this, we decided to publish three new packages:

  • react-instantsearch-core: contains all the core logic of React InstantSearch
  • react-instantsearch-dom: contains the DOM specific widgets and components
  • react-instantsearch-native: contains the React Native specific widgets and components

The react-instantsearch-core package is used internally by the two others. You don’t need to use this package on its own most of the time. You might want to use it for a new “binding”. We only support React DOM and React Native but the core package is not tied to any rendering engine. It means that you can create your own binding for React 360 for example.

This split also allows using the correct peerDependencies for each package. It was not the case previously because the package was the target of both React DOM and React Native. You can now have a clear vision about which version of React the package depends on:

  • react-instantsearch-core: has a peer dependency on react ≥ 15.3.0 < 17
  • react-instantsearch-dom: has a peer dependency on react ≥ 15.3.0 < 17 and react-dom ≥ 15.3.0 < 17
  • react-instantsearch-native: has a peer dependency on react ≥ 15.3.0 < 17 and react-native ≥ 0.32.0

As this new architecture is backward compatible, we encourage all our users to update to the new package. We recommend doing so because the library is correctly tree shaken with Webpack ≥ 4. Here are some metrics about the two different versions:

  Create React App + Webpack 3 Webpack 4
react-instantsearch/dom (CJS) 108 kB 104 kB
react-instantsearch-dom (ESM) 105 kB (-2.7%) 87 kB (-16.3%)

The sizes are after gzip. The sample application uses: configure, search-box, clear-refinements, refinement-list, hits, Custom Hits (with the connector, pagination.

The package react-instantsearch is deprecated in favor of react-instantsearch-dom and react-instantsearch-native.

Migration for React DOM

The first step is to remove the package react-instantsearch:

1
yarn remove react-instantsearch

The second step is to install the package react-instantsearch-dom:

1
yarn add react-instantsearch-dom

The last step is to update all your imports to the new package:

1
2
3
4
5
6
7
8
9
// With `react-instantsearch`
import { createConnector } from 'react-instantsearch';
import { InstantSearch } from 'react-instantsearch/dom';
import { connectMenu } from 'react-instantsearch/connectors';
import { createInstantSearch } from 'react-instantsearch/server';

// With `react-instantsearch-dom`
import { createConnector, InstantSearch, connectMenu } from 'react-instantsearch-dom';
import { createInstantSearch } from 'react-instantsearch-dom/server';

Migration for React Native

The first step is to remove the package react-instantsearch:

1
yarn remove react-instantsearch

The second step is to install the package react-instantsearch-native:

1
yarn add react-instantsearch-native

The last step is to update all your imports to the new package:

1
2
3
4
5
6
7
// with `react-instantsearch`
import { createConnector } from 'react-instantsearch';
import { InstantSearch } from 'react-instantsearch/native';
import { connectMenu } from 'react-instantsearch/connectors';

// with `react-instantsearch-native`
import { createConnector, InstantSearch, connectMenu } from 'react-instantsearch-native';

Upgrade from v4 to v5

React V5 introduces a complete revamp of the HTML output of most widgets. The goal of this release is to provide improved semantics to our users.

This release also introduces a new CSS naming convention which will be reused across all InstantSearch libraries. This will enable the possibility to develop cross-libraries CSS themes easily.

This guide will provide step-by-step migration information for each widget & connector.

Migration steps

Updating widget & connector names

A few widgets & connectors have been renamed in order to improve the meaning as well as consistency between each InstantSearch library. You will need to update your imports to match new names.

Complete list of changes:

Old name New name
ClearAll ClearRefinements
MultiRange NumericMenu
StarRating RatingMenu
Toggle ToggleRefinement
connectMultiRange connectNumericMenu
connectToggle connectToggleRefinement

Updating prop names

Some of the props have been renamed for a better consistency across the library. See below the list of all of them:

  • attributeNameattribute (multiple widgets)
  • limitMinlimit (HierarchicalMenu, Menu, RefinementList)
  • limitMaxshowMoreLimit (HierarchicalMenu, Menu, RefinementList)
  • maxPagestotalPages (Pagination)
  • pagesPaddingpadding (Pagination)
  • titleheader (Panel)
  • submitComponentsubmit (SearchBox)
  • resetComponentreset (SearchBox)
  • loadingIndicatorComponentloadingIndicator (SearchBox)
  • withSearchBoxsearchable (Menu, RefinementList)

Please refer to Widgets changes & Connectors changes sections for more detail informations.

Removing deprecation

We introduced a couple of months ago a warning about the usage of searchForFacetValues in favour of searchForItems & withSearchBox (now renamed searchable). This warning has been removed and so is the legacy API. Update your code if it’s not already the case. See below for the list of changes:

  • searchForFacetValueswithSearchBoxsearchable (RefinementList, Menu)
  • searchForFacetValuessearchForItems (createConnector, connectRefinementList, connectMenu)
  • searchParametersremoved on <InstantSearch> in favor of <Configure />

Please refer to Widgets changes & Connectors changes sections for more detail informations.

Updating styles

We are now making a unified theme for all InstantSearch versions, and React InstantSearch is the first to use it. It’s published as instantsearch.css, and causes the deprecation and removal of react-instantsearch-theme-algolia.

Here is the new jsDelivr links for the theme:

1
2
3
4
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/instantsearch.css@8.5.1/themes/reset-min.css" integrity="sha256-KvFgFCzgqSErAPu6y9gz/AhZAvzK48VJASu3DpNLCEQ=" crossorigin="anonymous">

<!-- or -->
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/instantsearch.css@8.5.1/themes/satellite-min.css" integrity="sha256-woeV7a4SRDsjDc395qjBJ4+ZhDdFn8AqswN1rlTO64E=" crossorigin="anonymous">

The reset theme is shipped with the satellite one, so no need to import it when you are using the satellite theme.

You can also use npm to install it, please refer to the Styling Widgets guide for more informations.

The CSS naming convention used for widgets has been changed in favour of the SUIT CSS methodology.

In order to fix broken stylings, please refer to the CSS naming equivalency table of each widget in the Widgets changes section.

Two new CSS themes have also been written:

  • reset.css
  • satellite.css

It’s strongly recommended to use at least reset.css to avoid the visual side effects induced by the new semantic changes made on most widgets.

Refer to the Styling Widgets guide for more information on how to install and use those CSS themes.

Adding className

All the built-in widgets now accept a prop className that will be forwarded to the root element of the widgets.

1
2
3
4
5
6
7
8
9
<RefinementList
  className="MyCustomRefinementList"
  attribute="category"
/>

// Will produce a DOM with
<div className="ais-RefinementList MyCustomRefinementList">
  // content of the RefinementList
</div>

Widgets changes

Note: the equivalency table only shows the replacement classes for existing classes. New CSS classes are also available. For more details, please refer to the Widgets API Reference.

InstantSearch

See the widget documentation page.

Naming

  • No change.

Behavior

  • searchParametersremoved in favour of <Configure />

CSS classes equivalency table

  • No change.

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Breadcrumb__root .ais-Breadcrumb
.ais-Breadcrumb__itemLinkRoot Removed. Target with :first-child instead.
.ais-Breadcrumb__rootLabel Removed. Target with :first-child instead.
.ais-Breadcrumb__item .ais-Breadcrumb-item
.ais-Breadcrumb__itemLink .ais-Breadcrumb-link
.ais-Breadcrumb__itemLabel Removed. Use .ais-Breadcrumb-link instead.
.ais-Breadcrumb__itemDisabled .ais-Breadcrumb-item--selected
.ais-Breadcrumb__separator .ais-Breadcrumb-separator
.ais-Breadcrumb__noRefinement .ais-Breadcrumb--noRefinement

ClearAll

See the widget documentation page.

Naming

  • Renamed to ClearRefinements.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-ClearAll__root .ais-ClearRefinements-button

CurrentRefinements

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-CurrentRefinements__root .ais-CurrentRefinements
.ais-CurrentRefinements__items .ais-CurrentRefinements-list
.ais-CurrentRefinements__item .ais-CurrentRefinements-item
.ais-CurrentRefinements__itemLabel .ais-CurrentRefinements-label
.ais-CurrentRefinements__itemClear .ais-CurrentRefinements-delete
.ais-CurrentRefinements__noRefinement .ais-CurrentRefinements--noRefinement

HierarchicalMenu

See the widget documentation page.

Naming

  • limitMinlimit
  • limitMaxshowMoreLimit

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-HierarchicalMenu__root .ais-HierarchicalMenu
.ais-HierarchicalMenu__items .ais-HierarchicalMenu-list
.ais-HierarchicalMenu__item .ais-HierarchicalMenu-item
.ais-HierarchicalMenu__itemSelected .ais-HierarchicalMenu-item--selected
.ais-HierarchicalMenu__itemParent .ais-HierarchicalMenu-item--parent
.ais-HierarchicalMenu__itemSelectedParent Removed. Use .ais-HierarchicalMenu-item--selected.ais-HierarchicalMenu-item--parent instead.
.ais-HierarchicalMenu__itemLink .ais-HierarchicalMenu-link
.ais-HierarchicalMenu__itemLabel .ais-HierarchicalMenu-label
.ais-HierarchicalMenu__itemCount .ais-HierarchicalMenu-count
.ais-HierarchicalMenu__itemItems .ais-HierarchicalMenu-list--child
.ais-HierarchicalMenu__showMore .ais-HierarchicalMenu-showMore
.ais-HierarchicalMenu__noRefinement .ais-HierarchicalMenu--noRefinement

Highlight

See the widget documentation page.

Naming

  • attributeNameattribute

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Highlight No change.
.ais-Highlight__highlighted .ais-Highlight-highlighted
.ais-Highlight__nonHighlighted .ais-Highlight-nonHighlighted

Hits

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Hits__root .ais-Hits

HitsPerPage

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-HitsPerPage__root .ais-HitsPerPage

InfiniteHits

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-InfiniteHits__root .ais-InfiniteHits
.ais-InfiniteHits__loadMore .ais-InfiniteHits-loadMore

See the widget documentation page.

Naming

  • attributeNameattribute
  • limitMinlimit
  • limitMaxshowMoreLimit
  • withSearchBoxsearchable

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Menu__root .ais-Menu
.ais-Menu__items .ais-Menu-list
.ais-Menu__item .ais-Menu-item
.ais-Menu__itemLinkSelected Removed. Use .ais-Menu-item--selected .ais-Menu-link instead.
.ais-Menu__itemLink .ais-Menu-link
.ais-Menu__itemLabelSelected Removed. Use .ais-Menu-item--selected .ais-Menu-label instead.
.ais-Menu__itemLabel .ais-Menu-label
.ais-Menu__itemCount .ais-Menu-count
.ais-Menu__itemCountSelected Removed. Use .ais-Menu-item--selected .ais-Menu-count instead.
.ais-Menu__showMore .ais-Menu-showMore
.ais-Menu__SearchBox .ais-Menu-searchBox
.ais-Menu__noRefinement .ais-Menu--noRefinement

See the widget documentation page.

Naming

  • attributeNameattribute

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-MenuSelect__select .ais-MenuSelect-select
.ais-MenuSelect__option .ais-MenuSelect-option

MultiRange

See the widget documentation page.

Naming

  • Renamed to NumericMenu.

  • attributeNameattribute

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-MultiRange__root .ais-NumericMenu
.ais-MultiRange__items .ais-NumericMenu-list
.ais-MultiRange__item .ais-NumericMenu-item
.ais-MultiRange__itemSelected .ais-NumericMenu-item--selected
.ais-MultiRange__itemLabel .ais-NumericMenu-label
.ais-MultiRange__itemLabelSelected Removed. Use .ais-NumericMenu-item--selected .ais-NumericMenu-label instead.
.ais-MultiRange__itemRadio .ais-NumericMenu-radio
.ais-MultiRange__itemRadioSelected Removed. Use .ais-NumericMenu-item--selected .ais-NumericMenu-radio instead.
.ais-MultiRange__noRefinement .ais-NumericMenu--noRefinement
.ais-MultiRange__itemNoRefinement .ais-NumericMenu-item--noRefinement
.ais-MultiRange__itemAll Removed.

Pagination

See the widget documentation page.

Naming

  • maxPagestotalPages
  • pagesPaddingpadding

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Pagination__root .ais-Pagination
.ais-Pagination__item .ais-Pagination-item
.ais-Pagination__itemFirst .ais-Pagination-item--firstPage
.ais-Pagination__itemPrevious .ais-Pagination-item--previousPage
.ais-Pagination__itemPage .ais-Pagination-item--page
.ais-Pagination__itemNext .ais-Pagination-item--nextPage
.ais-Pagination__itemLast .ais-Pagination-item--lastPage
.ais-Pagination__itemDisabled .ais-Pagination-item--disabled
.ais-Pagination__itemSelected .ais-Pagination-item--selected
.ais-Pagination__itemLink .ais-Pagination-link
.ais-Pagination__noRefinement .ais-Pagination--noRefinement

Panel

See the widget documentation page.

Naming

  • titleheader

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Panel__root .ais-Panel
.ais-Panel__title Removed.
.ais-Panel__noRefinement .ais-Panel--noRefinement

PoweredBy

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-PoweredBy__root .ais-PoweredBy
.ais-PoweredBy__searchBy .ais-PoweredBy-text
.ais-PoweredBy__algoliaLink .ais-PoweredBy-link

RangeInput

See the widget documentation page.

Naming

  • attributeNameattribute

Behavior

  • The default precision previously 2 has been updated to 0.

CSS classes equivalency table

Old class name New class name
.ais-RangeInput__root .ais-RangeInput
.ais-RangeInput__labelMin Removed.
.ais-RangeInput__inputMin .ais-RangeInput-input--min
.ais-RangeInput__separator .ais-RangeInput-separator
.ais-RangeInput__labelMax Removed.
.ais-RangeInput__inputMax .ais-RangeInput-input--max
.ais-RangeInput__submit .ais-RangeInput-submit
.ais-RangeInput__noRefinement .ais-RangeInput--noRefinement

RefinementList

See the widget documentation page.

Naming

  • attributeNameattribute
  • limitMinlimit
  • limitMaxshowMoreLimit
  • withSearchBoxsearchable

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-RefinementList__root .ais-RefinementList
.ais-RefinementList__items .ais-RefinementList-list
.ais-RefinementList__item .ais-RefinementList-item
.ais-RefinementList__itemSelected .ais-RefinementList-item--selected
.ais-RefinementList__itemCheckbox .ais-RefinementList-checkbox
.ais-RefinementList__itemCheckboxSelected Removed. Use .ais-RefinementList-item--selected .ais-RefinementList-checkbox instead.
.ais-RefinementList__itemLabel .ais-RefinementList-label
.ais-RefinementList__itemLabelSelected Removed. Use .ais-RefinementList-item--selected .ais-RefinementList-label instead.
.ais-RefinementList__itemCount .ais-RefinementList-count
.ais-RefinementList__itemCountSelected Removed. Use .ais-RefinementList-item--selected .ais-RefinementList-count instead.
.ais-RefinementList__showMore .ais-RefinementList-showMore
.ais-RefinementList__SearchBox .ais-RefinementList-searchBox
.ais-RefinementList__noRefinement .ais-RefinementList--noRefinement

See the widget documentation page.

Naming

  • submitComponentsubmit
  • resetComponentreset
  • loadingIndicatorComponentloadingIndicator

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-SearchBox__root .ais-SearchBox
.ais-SearchBox__wrapper .ais-SearchBox-form
.ais-SearchBox__input .ais-SearchBox-input
.ais-SearchBox__submit .ais-SearchBox-submit
.ais-SearchBox__reset .ais-SearchBox-reset
.ais-SearchBox__loading-indicator .ais-SearchBox-loadingIndicator

SortBy

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-SortBy__root .ais-SortBy

StarRating

See the widget documentation page.

Naming

  • Renamed to RatingMenu.

  • attributeNameattribute

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-StarRating__root .ais-RatingMenu
.ais-StarRating__ratingLink .ais-RatingMenu-link
.ais-StarRating__ratingLinkSelected Removed. Use .ais-RatingMenu-item--selected .ais-RatingMenu-link instead.
.ais-StarRating__ratingLinkDisabled Removed. Use .ais-RatingMenu-item--disabled .ais-RatingMenu-link instead.
.ais-StarRating__ratingIcon .ais-RatingMenu-starIcon
.ais-StarRating__ratingIconSelected Removed. Use .ais-RatingMenu-item--selected .ais-RatingMenu-starIcon instead.
.ais-StarRating__ratingIconDisabled Removed. Use .ais-RatingMenu-item--disabled .ais-RatingMenu-starIcon instead.
.ais-StarRating__ratingIconEmpty .ais-RatingMenu-starIcon--empty
.ais-StarRating__ratingIconEmptySelected Removed. Use .ais-RatingMenu-item--selected .ais-RatingMenu-starIcon--empty instead.
.ais-StarRating__ratingIconEmptyDisabled Removed. Use .ais-RatingMenu-item--disabled .ais-RatingMenu-starIcon--empty instead.
.ais-StarRating__ratingLabel .ais-RatingMenu-label
.ais-StarRating__ratingLabelSelected Removed. Use .ais-RatingMenu-item--selected .ais-RatingMenu-label instead.
.ais-StarRating__ratingLabelDisabled Removed. Use .ais-RatingMenu-item--disabled .ais-RatingMenu-label instead.
.ais-StarRating__ratingCount .ais-RatingMenu-count
.ais-StarRating__ratingCountSelected Removed. Use .ais-RatingMenu-item--selected .ais-RatingMenu-count instead.
.ais-StarRating__ratingCountDisabled Removed. Use .ais-RatingMenu-item--disabled .ais-RatingMenu-count instead.

Stats

See the widget documentation page.

Naming

  • No change.

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Stats__root .ais-Stats-text

Toggle

See the widget documentation page.

Naming

  • Renamed to ToggleRefinement.

  • attributeNameattribute

Behavior

  • No change.

CSS classes equivalency table

Old class name New class name
.ais-Toggle__root .ais-Toggle
.ais-Toggle__checkbox .ais-Toggle-checkbox
.ais-Toggle__label .ais-Toggle-label

Connectors changes

createConnector

See the connector documentation page.

Naming

  • searchForFacetValuessearchForItems

Behavior

  • No change.

connectCurrentRefinements

See the connector documentation page.

Naming

  • The property attributeName in the provided props items has been renamed attribute.

Behavior

  • No change.

connectHierarchicalMenu

See the connector documentation page.

Naming

  • limitMinlimit
  • limitMaxshowMoreLimit

Behavior

  • No change.

connectHighlight

See the connector documentation page.

Naming

  • The property attributeName in the provided props highlight has been renamed attribute.

Behavior

  • No change.

connectMenu

See the connector documentation page.

Naming

  • attributeNameattribute
  • limitMinlimit
  • limitMaxshowMoreLimit
  • withSearchBoxsearchable
  • searchForFacetValuessearchForItems

Behavior

  • No change.

connectMultiRange

See the connector documentation page.

Naming

  • Renamed to connectNumericMenu.

  • attributeNameattribute

Behavior

  • No change.

connectPagination

See the connector documentation page.

Naming

  • maxPagestotalPages
  • pagesPaddingpadding

Behavior

  • No change.

connectRange

See the connector documentation page.

Naming

  • attributeNameattribute

Behavior

  • The default precision previously 2 has been updated to 0.

connectRefinementList

See the connector documentation page.

Naming

  • attributeNameattribute
  • limitMinlimit
  • limitMaxshowMoreLimit
  • withSearchBoxsearchable
  • searchForFacetValuessearchForItems

Behavior

  • No change.

connectToggle

See the connector documentation page.

Naming

  • Renamed to connectToggleRefinement.

  • attributeNameattribute

Behavior

  • No change.
Did you find this page helpful?

InstantSearch / Angular / V4 / Guides

Upgrading Angular InstantSearch

Deprecated content
Angular InstantSearch is deprecated. Please use InstantSearch.js instead. For more information, see Migrating from Angular InstantSearch.

Migration from v4 to InstantSearch.js

You can use InstantSearch.js directly from Angular, as described in the Using InstantSearch.js in an Angular app guide. Migrating to that approach can be done as follows:

Replace the root component

Instead of the <ais-instantsearch> component, use the InstantSearch class from InstantSearch.js and expose this from a service.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
import { Injectable } from '@angular/core';
import { liteClient as algoliasearch } from 'algoliasearch/lite';
import InstantSearch from 'instantsearch.js/es/lib/InstantSearch';
import type { IndexWidget, Widget } from 'instantsearch.js';

const searchClient = algoliasearch(
  'YourApplicationID',
  'YourSearchOnlyAPIKey'
);

@Injectable({
  providedIn: 'root',
})
export class InstantSearchService {
  public instantSearchInstance: InstantSearch;

  constructor(router: Router) {
    this.instantSearchInstance = new InstantSearch({
      searchClient,
      indexName: 'instant_search',
      future: { preserveSharedStateOnUnmount: true },
    });
  }

  start() {
    this.instantSearchInstance.start();
  }

  addWidgets(widgets: Array<IndexWidget | Widget>) {
    this.instantSearchInstance.addWidgets(widgets);
  }

  removeWidgets(widgets: Array<IndexWidget | Widget>) {
    this.instantSearchInstance.removeWidgets(widgets);
  }
}

This can then be used in your app:

1
2
3
4
5
6
7
8
9
10
11
12
13
import { Component } from '@angular/core';
import { InstantSearchService } from '../instant-search.service';

@Component({
  selector: 'app-search',
  standalone: true,
  templateUrl: './search.component.html',
})
export class SearchComponent {
  ngAfterContentInit() {
    this.InstantSearchService.start();
  }
}

Replace widgets

Instead of using Angular InstantSearch widgets, use InstantSearch.js connectors:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
import { Component } from '@angular/core';
import { InstantSearchService } from '../instant-search.service';
import { BaseHit } from 'instantsearch.js';
import { connectHits, connectSearchBox } from 'instantsearch.js/es/connectors';

@Component({
  selector: 'app-search',
  standalone: true,
  templateUrl: './search.component.html',
})
export class SearchComponent {
  public hits: BaseHit[] = [];
  public refine: (query: string) => void;
  public query: string;

  constructor(private InstantSearchService: InstantSearchService) {
    this.InstantSearchService.addWidgets([
      connectSearchBox({ refine, query }) => {
        this.refine = refine;
        this.query = query;
      })({
        // ...widgetParameters
      }),
      connectHits(({ hits }) => {
        this.hits = hits;
      })({}),
    ]);
  }

  ngAfterContentInit() {
    this.InstantSearchService.start();
  }

  public search(event: Event) {
    this.refine!((event.target as HTMLInputElement).value);
  }
}

Replace custom widgets

If you have custom widgets, you can use InstantSearch.js connectors to create them, replacing the Angular InstantSearch BaseWidget class:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
-import { Component, Inject, forwardRef, Optional } from '@angular/core'
-import {
-  TypedBaseWidget,
-  NgAisInstantSearch,
-  NgAisIndex,
-} from 'angular-instantsearch'
+import { Component } from '@angular/core'
+import { InstantSearchService } from '../instant-search.service'
 import connectMenu, {
-  MenuConnectorParams,
   MenuWidgetDescription,
 } from 'instantsearch.js/es/connectors/menu/connectMenu'
 
 @Component({
   selector: 'app-menu-select',
   standalone: true,
   template: `
     <select class="menu-select" (change)="state.refine($event.target.value)">
       <option
         *ngFor="let item of state.items"
         [value]="item.value"
         [selected]="item.isRefined"
       >
         {{ item.label }}
       </option>
     </select>
   `,
 })
-export class MenuSelectComponent extends TypedBaseWidget<
-  MenuWidgetDescription,
-  MenuConnectorParams
-> {
+export class MenuSelectComponent {
   public state: MenuWidgetDescription['renderState'] = {
     items: [],
     refine: () => {},
     createURL: () => '#',
     canRefine: false,
     isShowingMore: false,
     canToggleShowMore: false,
     toggleShowMore: () => {},
     sendEvent: () => {},
   }
 
-  constructor(
-    @Inject(forwardRef(() => NgAisIndex))
-    @Optional()
-    public parentIndex: NgAisIndex,
-    @Inject(forwardRef(() => NgAisInstantSearch))
-    public instantSearchInstance: NgAisInstantSearch
-  ) {
-    super('MenuSelect')
-  }
-
-  public ngOnInit() {
-    this.createWidget(connectMenu, { attribute: 'categories' })
-    super.ngOnInit()
+  constructor(private InstantSearchService: InstantSearchService) {
+    this.InstantSearchService.addWidgets([
+      connectMenu(state => {
+        this.state = state
+      })({ attribute: 'categories' }),
+    ])
   }
 }

Migration from v3 to v4

Upgrade Angular to 10.x.x or later

Angular InstantSearch follows the support policy of Angular. Support for Angular < 10 is deprecated.

Use InstantSearch.js types

Angular InstantSearch now fully relies on InstantSearch.js types. If you rely on the types exposed by Angular InstantSearch, you need to replace them with their InstantSearch.js equivalent.

1
2
- import type { CurrentRefinementsState } from 'angular-instantsearch';
+ import type { CurrentRefinementsRenderState } from 'instantsearch.js/es/current-refinements/connectCurrentRefinements';

InstantSearch.js is now a dependency

InstantSearch.js is no longer referenced as a peer dependency. Make sure to uninstall your version and use the one installed with Angular InstantSearch.

Favor using TypedBaseWidget over BaseWidget

A type-capable alternative to BaseWidget called TypedBaseWidget was introduced. This is now the preferred way to create a custom widgets using the InstantSearch.js Connector API.

This is an optional change.

1
2
3
4
5
6
7
+ import type {
+   CurrentRefinementsWidgetDescription,
+   CurrentRefinementsConnectorParams,
+ } from 'instantsearch.js/es/current-refinements/connectCurrentRefinements';

- export class CustomCurrentRefinements extends BaseWidget { /* ... */ };
+ export class CustomCurrentRefinements extends TypedBaseWidget<CurrentRefinementsWidgetDescription, CurrentRefinementsConnectorParams> { /* ... */ };

Custom widgets require parentIndex and instantSearchInstance

Since Algolia now supports a new “parent” widget called index-widget, you need to change the constructor of your custom widget if it extends the BaseWidget class:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
import { Component, Inject, forwardRef, OnInit, Input } from '@angular/core'
import { BaseWidget, NgAisInstantSearch } from 'angular-instantsearch'
import { connectRefinementList } from 'instantsearch.js/es/connectors'

@Component({
  selector: 'my-widget',
  template: '',
})
export class MyWidget extends BaseWidget implements OnInit {
  @Input() public attribute: string

  constructor(
+    @Inject(forwardRef(() => NgAisIndex))
+    @Optional()
+    public parentIndex: NgAisIndex,
    @Inject(forwardRef(() => NgAisInstantSearch))
-    public instantSearchParent: NgAisInstantSearch
+    public instantSearchInstance: NgAisInstantSearch
  ) {
    super('MyWidget')
  }

  public ngOnInit() {
    this.createWidget(connectRefinementList, {
      attribute: this.attribute,
    })
    super.ngOnInit()
  }
}

Custom widgets using the helper API

This release includes version 3 of the algoliasearch-helper package. If you only use the built-in widgets or connectors, nothing changes for you.

This version of algoliasearch-helper no longer includes Lodash, which significantly reduces its bundle size (from 27.5 KB to 9.1&nbspKB Gzipped). If you’re using any methods from the helper, searchParameters or searchResults in custom widgets, please refer to the detailed change log of the package.

Custom widgets using a custom connector

Because the algoliasearch-helper package uses version 3, you have to replace the getConfiguration lifecycle with getWidgetSearchParameters and getWidgetState.

This also means that your custom widget takes part in the routing. You can exclude it from the URL via stateMapping.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
const connector = () => ({
  getConfiguration(searchParams) {
    return {
      disjunctiveFacets: ['myAttribute'],
    }
  },
  getWidgetSearchParameters(searchParameters, { uiState }) {
    return searchParameters.addDisjunctiveFacetRefinement(
      'myAttribute',
      uiState.myWidgetName.myAttribute
    )
  },
  getWidgetState(uiState, { searchParameters }) {
    return {
      ...uiState,
      myWidgetName: {
        myAttribute: searchParameters.getDisjunctiveRefinements('myAttribute'),
      },
    }
  },
})

Becomes:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
const connector = () => ({
  getWidgetSearchParameters(searchParameters, { uiState }) {
    return searchParameters
      .addDisjunctiveFacet('myAttribute')
      .addDisjunctiveFacetRefinement(
        'myAttribute',
        uiState.myWidgetName.myAttribute
      )
  },
  getWidgetState(uiState, { searchParameters }) {
    return {
      ...uiState,
      myWidgetName: {
        myAttribute: searchParameters.getDisjunctiveRefinements('myAttribute'),
      },
    }
  },
})

searchParameters option for ais-instantsearch

The searchParameters option has been removed from the instantsearch widget. However, you can replace it with the configure widget, like this:

1
2
3
4
5
6
7
<ais-instantsearch
-  [config]="{searchParameters: { hitsPerPage: 5 } }"
+  [config]="{}"
>
   <!-- children -->
+  <ais-configure [searchParameters]="{ hitsPerPage: 5 }"></ais-configure>
</ais-instantsearch>

You can now add initialUiState to your instantsearch widget. This overwrites specific search parameters that would otherwise be set during widget instantiation. initialUiState is only taken into account if a widget owning that state is mounted. A warning is displayed in development mode explaining which widget needs to be added for the UI state to have an effect.

A good example of this is the refinement-list widget:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
<ais-instantsearch
  [config]="{
-    searchParameters: {
-      disjunctiveFacets: ['brand'],
-      disjunctiveFacetsRefinements: {
-        brand: ['Apple'],
-      },
-    },
+    initialUiState: {
+      refinementList: {
+        brand: ['Apple'],
+      },
+    },
  }"
>
  <!-- children -->
  <ais-refinement-list attribute="brands"></ais-refinement-list>
</ais-instantsearch>

If you have a widget that you don’t want to display values for but still want to refine using this method, you can use a “Virtual Widget” like this:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
import { Component, Inject, forwardRef, OnInit, Input } from '@angular/core'
import { BaseWidget, NgAisInstantSearch } from 'angular-instantsearch'
import { connectRefinementList } from 'instantsearch.js/es/connectors'

@Component({
  selector: 'virtual-refinement-list',
  template: '',
})
export class VirtualRefinementList extends BaseWidget implements OnInit {
  @Input() public attribute: string

  public ngOnInit() {
    this.createWidget(connectRefinementList, {
      attribute: this.attribute,
    })
    super.ngOnInit()
  }
}

Routing

Even if you aren’t using multi-index search, the way in which UI state is stored has changed. It used to look like this:

1
2
3
4
{
  "query": "value",
  "page": 5
}

It now looks like this:

1
2
3
4
5
6
{
  "indexName": {
    "query": "value",
    "page": 5
  }
}

If you are using the default state mapping (simpleStateMapping) with the current version, you can replace it with singleIndexStateMapping('yourIndexName'). You have to change the code as followed:

1
2
3
4
5
6
7
8
 searchConfig = {
   indexName: 'myIndex',
   routing: {
-    stateMapping: simple(),
+    stateMapping: singleIndex('myIndex'),
   }
   // ...
 }

If you are using a custom state mapping, you have to loop over the outer level of the index widget and add this extra level to the routeToState. You can check the source for a reference on how to implement this.

For example, a stateMapping that maps a few properties would change like this:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
// Before
const stateMapping = {
  stateToRoute(uiState) {
    return {
      query: uiState.query,
      page: uiState.page,
      // ...
    }
  },

  routeToState(routeState) {
    return {
      query: routeState.query,
      page: routeState.page,
      // ...
    }
  },
}

// After
const stateMapping = {
  stateToRoute(uiState) {
    const indexUiState = uiState[indexName]
    return {
      query: indexUiState.query,
      page: indexUiState.page,
      // ...
    }
  },

  routeToState(routeState) {
    return {
      [indexName]: {
        query: routeState.query,
        page: routeState.page,
        // ...
      },
    }
  },
}

Configure

The configure widget is now included in the UI state. If you want to exclude it from the URL you can use the default stateMappings or exclude it in your custom state mapping. A good reason to exclude the configure widget from the UI state is to prevent users from adding any search parameters.

You must exclude this widget in both the stateToRoute, to keep it from appearing in the URL and routeToState, so that the URL doesn’t apply to the state.

Check the stateMapping source code for implementation details.

Other breaking changes

If you were using any InstantSearch.js APIs directly, you have to consult the InstantSearch.js v3 to v4 migration guide for any breaking changes.

Migration from v2 to v3

InstantSearch.js is now a peer dependency

$
npm install --save instantsearch@^3

RefinementList: “Show more” button controlled by showMore property

The display of the “Show more” button is no longer inferred by the showMoreLimit and the internal state property canToggleShowMore. It’s now controlled by a new input property: showMore: boolean = false.

If you want to use the “Show more” button on the refinement-list, make sure to set the showMore property to true

1
2
<ais-refinement-list [showMore]="true">
</ais-refinement-list>

NumericSelector widget has been removed

Use instead numeric-menu.

InfiniteHits: “Show More” button CSS class was renamed

The “Show more” button CSS class has been renamed from showMore to loadMore.

InstantSearch: appId, apiKey and createAlgoliaClient have been removed

This enforces the usage of the searchClient option. createAlgoliaClient has been removed as there is no longer a use case for it.

If you have (something like) the following code:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- more widgets -->
    </ais-instantsearch>
  `
})
export class AppComponent {
  config = {
    appId: 'YourApplicationID',
    apiKey: 'YourSearchOnlyAPIKey',
    /* ... */
  };
}

Replace it with:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
import { liteClient as algoliasearch } from 'algoliasearch/lite';

@Component({
  template: `
    <ais-instantsearch [config]="config">
      <!-- more widgets -->
    </ais-instantsearch>
  `
})
export class AppComponent {
  config = {
    searchClient: algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey'),
    /* ... */
  };
}

SortBy items property changed

The name key in items has been renamed to value.

Replace this:

1
2
3
4
5
6
7
<ais-sort-by
  [items]="[
    { name: 'products', label: 'Most relevant' },
    { name: 'products_price_desc', label: 'Highest price' }
  ]"
>
</ais-sort-by>

With this:

1
2
3
4
5
6
7
<ais-sort-by
  [items]="[
    { value: 'instant_search', label: 'Featured' },
    { value: 'instant_search_price_asc', label: 'Price asc.' },
    { value: 'instant_search_price_desc', label: 'Price desc.' }
  ]"
></ais-sort-by>

Migration from v0 to v1

Angular 2 and 4 support drop

To support Angular CLI 6 support for older versions was dropped, the only supported versions are now: 5, 6 and 7.

You can update your Angular 4 application by following this guide: https://update.angular.io/.

If you are using Angular +6 you will need an extra step, polyfill process.env by adding in your src/polyfill.ts:

1
(window as any).process = {env: {}};

Widget prefix

The ng- prefix is considered reserved for core implementations into Angular so it was dropped. All the widgets are now only starting with ais-:

1
2
3
4
5
6
7
8
9
10
11
<ais-instantsearch [config]="{...}">
  <ais-hits>
    <ng-template let-hits="hits">
      <div *ngFor="let hit of hits">
        Hit {{hit.objectID}}:
        <ais-highlight attribute="name" [hit]="hit">
        </ais-highlight>
      </div>
    </ng-template>
  </ais-hits>
</ais-instantsearch>

Server-side rendering

  • The createSSRAlgoliaClient until has been renamed to createSSRSearchClient
  • You can’t use the new routing: true option on <ais-instantsearch> widget until resolution of preboot#82
Did you find this page helpful?